# ajaxcontent - version 2.0

'ajaxcontent' is a lightweight AJAX script for preloading images and displaying them in a container.

## What's new in v2.0?
Put simply, it is cleaner. Hence, significantly smaller and faster.

## Usage
You will need to include the 'ajaxcontent.v2.0.js.min' script in your index &lt;head&gt;, using something like:
<pre><code>&lt;script type="text/javascript" src="ajaxcontent.v2.0.js.min"&gt;&lt;/script&gt;</pre>

To request a new page use:
<pre><code>ajaxcontent.load('currentLocation', 'currentContainer', 'nextLocation', 'nextContainer')</code></pre>
Where:
<ul>
	<li><strong>currentLocation</strong> is the page that contains the link. This is used for the history stack. It is the page that is loaded when the user clicks 'Back'. Example: 'page1.html'</li>
	<li><strong>currentContainer</strong> is the div id that contains the page (and ergo, the link). Example: 'container'</li>
	<li><strong>nextLocation</strong> is the page that you want to request. Example: 'page2.html'</li>
	<li><strong>nextContainer</strong> is the div you want to display the requested page in. Example: 'container'</li>
</ul>

An example of a link that can be used to call the function is:
<pre><code>&lt;a href="#" onClick="ajaxcontent.load('page1.html','container','page2.html','container');"&gt;Click here&lt;/a&gt;</code></pre>
This link will replace the contents in 'container' (which are supposed to be from 'page1.html'), with contents from 'page2.html'.

## Showing the user a pre-loader animation and loading div
If you want to show the user a little loading graphic while the script runs, include a div with id = 'loader' in your html body. For example:
<pre><code>&lt;div id="loader" style="visibility:hidden;">
	&lt;p&gt;&lt;img src="ajax-loader.gif"&gt;
	&lt;br&gt;Loading...&lt;/p&gt;
&lt;/div&gt;
</code></pre>
I recommend that you use CSS (#loader) to adjust the loader's appearance. Check out the CSS code in demo.html for guidance.

## Refresh
You can refresh/retry the last request using:
<pre><code>ajaxcontent.refresh()</code></pre>

## Using the History Stack
'Locations' and 'Containers' are added to the history stack automatically. 'refresh' requests do not re-add data to the stack, they are "blank" requests.

To avoid adding the current page/container to the history stack, simply leave the current page/container fields blank in the request. Example:
<pre><code>ajaxcontent.load('', '', 'nextLocation', 'nextContainer')</code></pre>

You can manually access the history stack using the arrays:
<pre><code>ajaxcontent.locationHist</code></pre>
<pre><code>ajaxcontent.containerHist</code></pre>

You can also use them for a back button. An example of a function for the back button is:
<pre><code>function goBack() {
	//load previous page
	ajaxcontent.load('','',ajaxcontent.locationHist[ajaxcontent.locationHist.length-1], ajaxcontent.containerHist[ajaxcontent.containerHist.length-1]);
	
	//remove one location from the history 'stack'
	ajaxcontent.locationHist.length = ajaxcontent.locationHist.length-1;
	ajaxcontent.containerHist.length = ajaxcontent.containerHist.length-1;
}
</code></pre>

You can also clear the history stack using:
<pre><code>ajaxcontent.clearHistoryTo(toLength)</code></pre>
Where <strong>toLength</strong> is an integer representing the desired stack size.

# DEMO

Upload the files onto a server and access 'demo.html' using HTTP. The request will not work if the file is not being accessed is not on the same server as the 'demo.html' file.
The demo shows a basic request, with preloading of two images. It also allows you to display and clear the history stack that is created.


# LICENSE (MIT)
Copyright (C) 2012 Hadi Michael

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.